package es.ucm.fdi.grasia.faerie.examples.bottomUp.queryApp;

import org.apache.felix.scr.annotations.Component;
import org.apache.log4j.Logger;

import es.ucm.fdi.grasia.faerie.core.AbstractContextObserverComponent;
import es.ucm.fdi.grasia.faerie.core.ContextEvent;
import es.ucm.fdi.grasia.faerie.core.Relationship;
import es.ucm.fdi.grasia.faerie.core.model.IncludedEntities;
import es.ucm.fdi.grasia.faerie.examples.bottomUp.model.Attribute2;
import es.ucm.fdi.grasia.faerie.examples.bottomUp.model.Sensor;
import es.ucm.fdi.grasia.faerie.model.base.AttributeConditionSet;

@Component(inherit = true)
@SuppressWarnings({ "unchecked", "rawtypes" })
public class BottomUpQueryApp extends AbstractContextObserverComponent {

	private AttributeConditionSet<Sensor, Attribute2, String> query = null;

	@Override
	public void addMyReferencedEntities() {
		query = this.addReferencedEntity(new AttributeConditionSet<Sensor, Attribute2, String>(
				Sensor.class, Attribute2.class, "Sensor 2 NEXT"));
	}

	@Override
	public void doActivate() {
		IncludedEntities<Sensor> rel = new IncludedEntities<Sensor>(query);
		rel = this.contextRequest(rel);

		this.putObservedElement(rel);

		Logger.getLogger(this.getClass()).info("Initial relInstance: " + rel);
	}

	@Override
	public void elementUpdated(Relationship rel, ContextEvent event) {
		Logger.getLogger(this.getClass()).info("RelInstance updated: " + rel.getAllTargetEntities());
	}
}
